#ifdef __GL12__
  #include <GL/glut.h>
#else
  #include <GL/gl.h>
  #include <GL/glu.h>
  #include <aux.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>

#define VERSION "0.4.1"
#ifndef pi
  #define pi 3.14159265359
#endif
#define RAD(grad) (grad*pi/180)

#define STD_TRANS glTranslatef(0.0, -1.0, -5.1)
#define STD_TRANS_NEG glTranslatef(0.0, 1.0, 5.1)

#define BUFSIZE 1024

/* ****************************************************************** */

/* structs */
struct sub_dir_info_struct {
  char sub_dir_name[256];
  int sub_dirs;
};

struct dir_info_struct {
  char dir_name[256];
  int sub_dirs;
  int non_dirs;
  struct sub_dir_info_struct *sub_info;
};

/* ****************************************************************** */
/* they come from main.c */

  GLvoid DrawScene(GLvoid);
#ifdef __glut_h__
  GLvoid initialize(GLvoid);
  GLvoid reshape(int w, int h);
#else
  GLvoid initialize(char *);
  GLvoid resize(GLsizei , GLsizei );
#endif
  
  /* initializes the light */
  GLvoid init_light(GLvoid);
  
  /* key functions */
  GLvoid leftkey(GLvoid);
  GLvoid rightkey(GLvoid);
  GLvoid upkey(GLvoid);
  GLvoid downkey(GLvoid);
  GLvoid rupkey(GLvoid);
  GLvoid rdownkey(GLvoid);
  GLvoid tokey(GLvoid);
  GLvoid awaykey(GLvoid);
  GLvoid resetkey(GLvoid);
  
  /* enable/disable file viewing */
  GLvoid viewfiles(GLvoid);
  /* enable/disable help */
  GLvoid viewhelp(GLvoid);
  
  /* draw Objects */
  GLvoid drawprisma(GLint corners);
  GLvoid drawText(GLvoid);
  GLvoid drawfiles(GLvoid);
  
  /* process clicked objects */
  GLvoid printHits (GLint hits, GLuint buffer[]);
  
#ifdef __glut_h__
  /* write selected objects in buffer */
  GLvoid doPicking(int button, int state, int x, int y);
  GLvoid keyboard(unsigned char key, int x, int y); /* glut */
  GLvoid mouseMove(int x, int y);
#else
  /* write selected objects in buffer */
  GLvoid doPicking(AUX_EVENTREC *event);
  GLvoid startMove(AUX_EVENTREC *event);
  GLvoid stopMove(AUX_EVENTREC *event);
  GLvoid mouseMove(AUX_EVENTREC *event);
#endif
  
/* end (from main.c) */
/* ****************************************************************** */
/* they come from filestuff.c */

  /* fills dir_info with all information needed to draw the scene */
  int get_dir_info(char *dirname, struct dir_info_struct *dir_info);
  /* returns an string containing a ls -1 */
  char **ls1(const char *);
  /* returns a string with output of command `file` */
  char *file_output(const char *name);

/* end (from filestuff.c) */
/* ****************************************************************** */

/* letter headers */
/* they come from letters.c */

/* drawWord returns number of drawn letters */
int drawWord(char *todraw); /* Draws a String on the Display */

/* the lowercase letters are not functions, but drawWord understands them */
GLvoid z0(GLvoid);		/* This draws a z0 */
GLvoid z1(GLvoid);		/* This draws a z1 */
GLvoid z2(GLvoid);		/* This draws a z2 */
GLvoid z3(GLvoid);		/* This draws a z3 */
GLvoid z4(GLvoid);		/* This draws a z4 */
GLvoid z5(GLvoid);		/* This draws a z5 */
GLvoid z6(GLvoid);		/* This draws a z6 */
GLvoid z7(GLvoid);		/* This draws a z7 */
GLvoid z8(GLvoid);		/* This draws a z8 */
GLvoid z9(GLvoid);		/* This draws a z9 */
GLvoid A(GLvoid);		/* This draws a A */
GLvoid B(GLvoid);		/* This draws a B */
GLvoid C(GLvoid);		/* This draws a C */
GLvoid D(GLvoid);		/* This draws a D */
GLvoid E(GLvoid);		/* This draws a E */
GLvoid F(GLvoid);		/* This draws a F */
GLvoid G(GLvoid);		/* This draws a G */
GLvoid H(GLvoid);		/* This draws a H */
GLvoid I(GLvoid);		/* This draws a I */
GLvoid J(GLvoid);		/* This draws a J */
GLvoid K(GLvoid);		/* This draws a K */
GLvoid L(GLvoid);		/* This draws a L */
GLvoid M(GLvoid);		/* This draws a M */
GLvoid N(GLvoid);		/* This draws a N */
GLvoid O(GLvoid);		/* This draws a O */
GLvoid P(GLvoid);		/* This draws a P */
GLvoid Q(GLvoid);		/* This draws a Q */
GLvoid R(GLvoid);		/* This draws a R */
GLvoid S(GLvoid);		/* This draws a S */
GLvoid T(GLvoid);		/* This draws a T */
GLvoid U(GLvoid);		/* This draws a U */
GLvoid V(GLvoid);		/* This draws a V */
GLvoid W(GLvoid);		/* This draws a W */
GLvoid X(GLvoid);		/* This draws a X */
GLvoid Y(GLvoid);		/* This draws a Y */
GLvoid Z(GLvoid);		/* This draws a Z */
GLvoid Slash(GLvoid);		/* This draws a Slash */
GLvoid BSlash(GLvoid);		/* This draws a BSlash */
GLvoid Newline(GLvoid);		/* This draws a Newline */
GLvoid Procent(GLvoid);		/* This draws a Procent */
GLvoid Plus(GLvoid);		/* This draws a Plus */
GLvoid Minus(GLvoid);		/* This draws a Minus */
GLvoid Asterisk(GLvoid);	/* This draws a Asterisk */
GLvoid Equal(GLvoid);		/* This draws a Equal */
GLvoid Dollar(GLvoid);		/* This draws a Dollar */
GLvoid At(GLvoid);		/* This draws a At */
GLvoid Hash(GLvoid);		/* This draws a Hash */
GLvoid Dquotes(GLvoid);		/* This draws a Dquotes */
GLvoid Squotes(GLvoid);		/* This draws a Squotes */
GLvoid Bquotes(GLvoid);		/* This draws a Bquotes */
GLvoid Dot(GLvoid);		/* This draws a Dot */
GLvoid Comma(GLvoid);		/* This draws a Comma */
GLvoid Colon(GLvoid);		/* This draws a Colon */
GLvoid Semicolon(GLvoid);	/* This draws a Semicolon */
GLvoid Emark(GLvoid);		/* This draws a Emark */
GLvoid Qmark(GLvoid);		/* This draws a Qmark */
GLvoid NbracketL(GLvoid);	/* This draws a NbracketL */
GLvoid NbracketR(GLvoid);	/* This draws a NbracketR */
GLvoid RbracketL(GLvoid);	/* This draws a RbracketL */
GLvoid RbracketR(GLvoid);	/* This draws a RbracketR */
GLvoid SbracketL(GLvoid);	/* This draws a SbracketL */
GLvoid SbracketR(GLvoid);	/* This draws a SbracketR */
GLvoid HbracketL(GLvoid);	/* This draws a HbracketL */
GLvoid HbracketR(GLvoid);	/* This draws a HbracketR */
GLvoid Pipe(GLvoid);		/* This draws a Pipe */
GLvoid Underscore(GLvoid);	/* This draws a Underscore */
GLvoid Tilde(GLvoid);		/* This draws a Tilde */
GLvoid Caret(GLvoid);		/* This draws a Caret */
GLvoid Degree(GLvoid);		/* This draws a Degree */
GLvoid Paragraph(GLvoid);	/* This draws a Paragraph */
GLvoid Reference(GLvoid);	/* This draws a Reference */

/* end of myhdrs.h */
/* ****************************************************************** */
